var NodeSelector = (function(exports, axios, ptokensNode, ptokensUtils) {
  'use strict'

  axios = axios && axios.hasOwnProperty('default') ? axios['default'] : axios

  function createCommonjsModule(fn, module) {
    return (
      (module = { exports: {} }), fn(module, module.exports), module.exports
    )
  }

  var runtime_1 = createCommonjsModule(function(module) {
    var runtime = (function(exports) {
      var Op = Object.prototype
      var hasOwn = Op.hasOwnProperty
      var undefined$1
      var $Symbol = typeof Symbol === 'function' ? Symbol : {}
      var iteratorSymbol = $Symbol.iterator || '@@iterator'
      var asyncIteratorSymbol = $Symbol.asyncIterator || '@@asyncIterator'
      var toStringTagSymbol = $Symbol.toStringTag || '@@toStringTag'
      function wrap(innerFn, outerFn, self, tryLocsList) {
        var protoGenerator =
          outerFn && outerFn.prototype instanceof Generator
            ? outerFn
            : Generator
        var generator = Object.create(protoGenerator.prototype)
        var context = new Context(tryLocsList || [])
        generator._invoke = makeInvokeMethod(innerFn, self, context)
        return generator
      }
      exports.wrap = wrap
      function tryCatch(fn, obj, arg) {
        try {
          return { type: 'normal', arg: fn.call(obj, arg) }
        } catch (err) {
          return { type: 'throw', arg: err }
        }
      }
      var GenStateSuspendedStart = 'suspendedStart'
      var GenStateSuspendedYield = 'suspendedYield'
      var GenStateExecuting = 'executing'
      var GenStateCompleted = 'completed'
      var ContinueSentinel = {}
      function Generator() {}
      function GeneratorFunction() {}
      function GeneratorFunctionPrototype() {}
      var IteratorPrototype = {}
      IteratorPrototype[iteratorSymbol] = function() {
        return this
      }
      var getProto = Object.getPrototypeOf
      var NativeIteratorPrototype = getProto && getProto(getProto(values([])))
      if (
        NativeIteratorPrototype &&
        NativeIteratorPrototype !== Op &&
        hasOwn.call(NativeIteratorPrototype, iteratorSymbol)
      ) {
        IteratorPrototype = NativeIteratorPrototype
      }
      var Gp = (GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(
        IteratorPrototype
      ))
      GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype
      GeneratorFunctionPrototype.constructor = GeneratorFunction
      GeneratorFunctionPrototype[
        toStringTagSymbol
      ] = GeneratorFunction.displayName = 'GeneratorFunction'
      function defineIteratorMethods(prototype) {
        ;['next', 'throw', 'return'].forEach(function(method) {
          prototype[method] = function(arg) {
            return this._invoke(method, arg)
          }
        })
      }
      exports.isGeneratorFunction = function(genFun) {
        var ctor = typeof genFun === 'function' && genFun.constructor
        return ctor
          ? ctor === GeneratorFunction ||
              (ctor.displayName || ctor.name) === 'GeneratorFunction'
          : false
      }
      exports.mark = function(genFun) {
        if (Object.setPrototypeOf) {
          Object.setPrototypeOf(genFun, GeneratorFunctionPrototype)
        } else {
          genFun.__proto__ = GeneratorFunctionPrototype
          if (!(toStringTagSymbol in genFun)) {
            genFun[toStringTagSymbol] = 'GeneratorFunction'
          }
        }
        genFun.prototype = Object.create(Gp)
        return genFun
      }
      exports.awrap = function(arg) {
        return { __await: arg }
      }
      function AsyncIterator(generator) {
        function invoke(method, arg, resolve, reject) {
          var record = tryCatch(generator[method], generator, arg)
          if (record.type === 'throw') {
            reject(record.arg)
          } else {
            var result = record.arg
            var value = result.value
            if (
              value &&
              typeof value === 'object' &&
              hasOwn.call(value, '__await')
            ) {
              return Promise.resolve(value.__await).then(
                function(value) {
                  invoke('next', value, resolve, reject)
                },
                function(err) {
                  invoke('throw', err, resolve, reject)
                }
              )
            }
            return Promise.resolve(value).then(
              function(unwrapped) {
                result.value = unwrapped
                resolve(result)
              },
              function(error) {
                return invoke('throw', error, resolve, reject)
              }
            )
          }
        }
        var previousPromise
        function enqueue(method, arg) {
          function callInvokeWithMethodAndArg() {
            return new Promise(function(resolve, reject) {
              invoke(method, arg, resolve, reject)
            })
          }
          return (previousPromise = previousPromise
            ? previousPromise.then(
                callInvokeWithMethodAndArg,
                callInvokeWithMethodAndArg
              )
            : callInvokeWithMethodAndArg())
        }
        this._invoke = enqueue
      }
      defineIteratorMethods(AsyncIterator.prototype)
      AsyncIterator.prototype[asyncIteratorSymbol] = function() {
        return this
      }
      exports.AsyncIterator = AsyncIterator
      exports.async = function(innerFn, outerFn, self, tryLocsList) {
        var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList))
        return exports.isGeneratorFunction(outerFn)
          ? iter
          : iter.next().then(function(result) {
              return result.done ? result.value : iter.next()
            })
      }
      function makeInvokeMethod(innerFn, self, context) {
        var state = GenStateSuspendedStart
        return function invoke(method, arg) {
          if (state === GenStateExecuting) {
            throw new Error('Generator is already running')
          }
          if (state === GenStateCompleted) {
            if (method === 'throw') {
              throw arg
            }
            return doneResult()
          }
          context.method = method
          context.arg = arg
          while (true) {
            var delegate = context.delegate
            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context)
              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue
                return delegateResult
              }
            }
            if (context.method === 'next') {
              context.sent = context._sent = context.arg
            } else if (context.method === 'throw') {
              if (state === GenStateSuspendedStart) {
                state = GenStateCompleted
                throw context.arg
              }
              context.dispatchException(context.arg)
            } else if (context.method === 'return') {
              context.abrupt('return', context.arg)
            }
            state = GenStateExecuting
            var record = tryCatch(innerFn, self, context)
            if (record.type === 'normal') {
              state = context.done ? GenStateCompleted : GenStateSuspendedYield
              if (record.arg === ContinueSentinel) {
                continue
              }
              return {
                value: record.arg,
                done: context.done
              }
            } else if (record.type === 'throw') {
              state = GenStateCompleted
              context.method = 'throw'
              context.arg = record.arg
            }
          }
        }
      }
      function maybeInvokeDelegate(delegate, context) {
        var method = delegate.iterator[context.method]
        if (method === undefined$1) {
          context.delegate = null
          if (context.method === 'throw') {
            if (delegate.iterator['return']) {
              context.method = 'return'
              context.arg = undefined$1
              maybeInvokeDelegate(delegate, context)
              if (context.method === 'throw') {
                return ContinueSentinel
              }
            }
            context.method = 'throw'
            context.arg = new TypeError(
              "The iterator does not provide a 'throw' method"
            )
          }
          return ContinueSentinel
        }
        var record = tryCatch(method, delegate.iterator, context.arg)
        if (record.type === 'throw') {
          context.method = 'throw'
          context.arg = record.arg
          context.delegate = null
          return ContinueSentinel
        }
        var info = record.arg
        if (!info) {
          context.method = 'throw'
          context.arg = new TypeError('iterator result is not an object')
          context.delegate = null
          return ContinueSentinel
        }
        if (info.done) {
          context[delegate.resultName] = info.value
          context.next = delegate.nextLoc
          if (context.method !== 'return') {
            context.method = 'next'
            context.arg = undefined$1
          }
        } else {
          return info
        }
        context.delegate = null
        return ContinueSentinel
      }
      defineIteratorMethods(Gp)
      Gp[toStringTagSymbol] = 'Generator'
      Gp[iteratorSymbol] = function() {
        return this
      }
      Gp.toString = function() {
        return '[object Generator]'
      }
      function pushTryEntry(locs) {
        var entry = { tryLoc: locs[0] }
        if (1 in locs) {
          entry.catchLoc = locs[1]
        }
        if (2 in locs) {
          entry.finallyLoc = locs[2]
          entry.afterLoc = locs[3]
        }
        this.tryEntries.push(entry)
      }
      function resetTryEntry(entry) {
        var record = entry.completion || {}
        record.type = 'normal'
        delete record.arg
        entry.completion = record
      }
      function Context(tryLocsList) {
        this.tryEntries = [{ tryLoc: 'root' }]
        tryLocsList.forEach(pushTryEntry, this)
        this.reset(true)
      }
      exports.keys = function(object) {
        var keys = []
        for (var key in object) {
          keys.push(key)
        }
        keys.reverse()
        return function next() {
          while (keys.length) {
            var key = keys.pop()
            if (key in object) {
              next.value = key
              next.done = false
              return next
            }
          }
          next.done = true
          return next
        }
      }
      function values(iterable) {
        if (iterable) {
          var iteratorMethod = iterable[iteratorSymbol]
          if (iteratorMethod) {
            return iteratorMethod.call(iterable)
          }
          if (typeof iterable.next === 'function') {
            return iterable
          }
          if (!isNaN(iterable.length)) {
            var i = -1,
              next = function next() {
                while (++i < iterable.length) {
                  if (hasOwn.call(iterable, i)) {
                    next.value = iterable[i]
                    next.done = false
                    return next
                  }
                }
                next.value = undefined$1
                next.done = true
                return next
              }
            return (next.next = next)
          }
        }
        return { next: doneResult }
      }
      exports.values = values
      function doneResult() {
        return { value: undefined$1, done: true }
      }
      Context.prototype = {
        constructor: Context,
        reset: function(skipTempReset) {
          this.prev = 0
          this.next = 0
          this.sent = this._sent = undefined$1
          this.done = false
          this.delegate = null
          this.method = 'next'
          this.arg = undefined$1
          this.tryEntries.forEach(resetTryEntry)
          if (!skipTempReset) {
            for (var name in this) {
              if (
                name.charAt(0) === 't' &&
                hasOwn.call(this, name) &&
                !isNaN(+name.slice(1))
              ) {
                this[name] = undefined$1
              }
            }
          }
        },
        stop: function() {
          this.done = true
          var rootEntry = this.tryEntries[0]
          var rootRecord = rootEntry.completion
          if (rootRecord.type === 'throw') {
            throw rootRecord.arg
          }
          return this.rval
        },
        dispatchException: function(exception) {
          if (this.done) {
            throw exception
          }
          var context = this
          function handle(loc, caught) {
            record.type = 'throw'
            record.arg = exception
            context.next = loc
            if (caught) {
              context.method = 'next'
              context.arg = undefined$1
            }
            return !!caught
          }
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i]
            var record = entry.completion
            if (entry.tryLoc === 'root') {
              return handle('end')
            }
            if (entry.tryLoc <= this.prev) {
              var hasCatch = hasOwn.call(entry, 'catchLoc')
              var hasFinally = hasOwn.call(entry, 'finallyLoc')
              if (hasCatch && hasFinally) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true)
                } else if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc)
                }
              } else if (hasCatch) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true)
                }
              } else if (hasFinally) {
                if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc)
                }
              } else {
                throw new Error('try statement without catch or finally')
              }
            }
          }
        },
        abrupt: function(type, arg) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i]
            if (
              entry.tryLoc <= this.prev &&
              hasOwn.call(entry, 'finallyLoc') &&
              this.prev < entry.finallyLoc
            ) {
              var finallyEntry = entry
              break
            }
          }
          if (
            finallyEntry &&
            (type === 'break' || type === 'continue') &&
            finallyEntry.tryLoc <= arg &&
            arg <= finallyEntry.finallyLoc
          ) {
            finallyEntry = null
          }
          var record = finallyEntry ? finallyEntry.completion : {}
          record.type = type
          record.arg = arg
          if (finallyEntry) {
            this.method = 'next'
            this.next = finallyEntry.finallyLoc
            return ContinueSentinel
          }
          return this.complete(record)
        },
        complete: function(record, afterLoc) {
          if (record.type === 'throw') {
            throw record.arg
          }
          if (record.type === 'break' || record.type === 'continue') {
            this.next = record.arg
          } else if (record.type === 'return') {
            this.rval = this.arg = record.arg
            this.method = 'return'
            this.next = 'end'
          } else if (record.type === 'normal' && afterLoc) {
            this.next = afterLoc
          }
          return ContinueSentinel
        },
        finish: function(finallyLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i]
            if (entry.finallyLoc === finallyLoc) {
              this.complete(entry.completion, entry.afterLoc)
              resetTryEntry(entry)
              return ContinueSentinel
            }
          }
        },
        catch: function(tryLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i]
            if (entry.tryLoc === tryLoc) {
              var record = entry.completion
              if (record.type === 'throw') {
                var thrown = record.arg
                resetTryEntry(entry)
              }
              return thrown
            }
          }
          throw new Error('illegal catch attempt')
        },
        delegateYield: function(iterable, resultName, nextLoc) {
          this.delegate = {
            iterator: values(iterable),
            resultName: resultName,
            nextLoc: nextLoc
          }
          if (this.method === 'next') {
            this.arg = undefined$1
          }
          return ContinueSentinel
        }
      }
      return exports
    })(module.exports)
    try {
      regeneratorRuntime = runtime
    } catch (accidentalStrictMode) {
      Function('r', 'regeneratorRuntime = r')(runtime)
    }
  })

  var regenerator = runtime_1

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg)
      var value = info.value
    } catch (error) {
      reject(error)
      return
    }
    if (info.done) {
      resolve(value)
    } else {
      Promise.resolve(value).then(_next, _throw)
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self = this,
        args = arguments
      return new Promise(function(resolve, reject) {
        var gen = fn.apply(self, args)
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, 'next', value)
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, 'throw', err)
        }
        _next(undefined)
      })
    }
  }
  var asyncToGenerator = _asyncToGenerator

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError('Cannot call a class as a function')
    }
  }
  var classCallCheck = _classCallCheck

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i]
      descriptor.enumerable = descriptor.enumerable || false
      descriptor.configurable = true
      if ('value' in descriptor) descriptor.writable = true
      Object.defineProperty(target, descriptor.key, descriptor)
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps)
    if (staticProps) _defineProperties(Constructor, staticProps)
    return Constructor
  }
  var createClass = _createClass

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i]
      }
      return arr2
    }
  }
  var arrayWithoutHoles = _arrayWithoutHoles

  function _iterableToArray(iter) {
    if (
      Symbol.iterator in Object(iter) ||
      Object.prototype.toString.call(iter) === '[object Arguments]'
    )
      return Array.from(iter)
  }
  var iterableToArray = _iterableToArray

  function _nonIterableSpread() {
    throw new TypeError('Invalid attempt to spread non-iterable instance')
  }
  var nonIterableSpread = _nonIterableSpread

  function _toConsumableArray(arr) {
    return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread()
  }
  var toConsumableArray = _toConsumableArray

  var NODE_CONNECTION_TIMEOUT = 5000
  var DEFAULT_TIMEOUT = 10000
  var BOOT_TESTNET_ENDPOINT = 'https://testnet_bootnode-eu-1.p.network/'
  var BOOT_MAINNET_ENDPOINT = 'https://mainnet_bootnode-eu-1.p.network'
  var createApi = function createApi(_endpoint) {
    return axios.create({
      baseURL: _endpoint,
      headers: {
        'Access-Control-Allow-Origin': '*',
        'Access-Control-Allow-Methods': 'GET, POST, OPTIONS',
        'Access-Control-Allow-Headers': 'Origin, Content-Type',
        'Content-Type': 'application/json'
      }
    })
  }
  var getBootNodeApi = function getBootNodeApi(_network) {
    return _network === 'mainnet'
      ? createApi(BOOT_MAINNET_ENDPOINT)
      : createApi(BOOT_TESTNET_ENDPOINT)
  }
  var makeApiCallWithTimeout = (function() {
    var _ref = asyncToGenerator(
      regenerator.mark(function _callee(_api, _callType, _apiPath) {
        var _params,
          _timeout,
          _api2,
          api,
          CancelToken,
          options,
          details,
          res,
          _args = arguments
        return regenerator.wrap(
          function _callee$(_context) {
            while (1) {
              switch ((_context.prev = _context.next)) {
                case 0:
                  _params =
                    _args.length > 3 && _args[3] !== undefined ? _args[3] : []
                  _timeout =
                    _args.length > 4 && _args[4] !== undefined
                      ? _args[4]
                      : DEFAULT_TIMEOUT
                  _context.prev = 2
                  api = null
                  if (!(Promise.resolve(_api) === _api)) {
                    _context.next = 10
                    break
                  }
                  _context.next = 7
                  return _api
                case 7:
                  api = _context.sent
                  _context.next = 11
                  break
                case 10:
                  api = _api
                case 11:
                  CancelToken = axios.CancelToken
                  options = {
                    cancelToken: _timeout
                      ? new CancelToken(function(_cancel) {
                          return setTimeout(function() {
                            return _cancel(
                              'timeout of '.concat(_timeout, 'ms exceeded')
                            )
                          }, _timeout)
                        })
                      : undefined
                  }
                  details = [_apiPath].concat(
                    toConsumableArray(
                      _callType === 'GET' ? [options] : [_params, options]
                    )
                  )
                  _context.next = 16
                  return (_api2 = api)[_callType.toLowerCase()].apply(
                    _api2,
                    toConsumableArray(details)
                  )
                case 16:
                  res = _context.sent
                  return _context.abrupt('return', res.data)
                case 20:
                  _context.prev = 20
                  _context.t0 = _context['catch'](2)
                  throw new Error(_context.t0.message)
                case 23:
                case 'end':
                  return _context.stop()
              }
            }
          },
          _callee,
          null,
          [[2, 20]]
        )
      })
    )
    return function makeApiCallWithTimeout(_x, _x2, _x3) {
      return _ref.apply(this, arguments)
    }
  })()

  var NodeSelector = (function() {
    function NodeSelector(_configs) {
      classCallCheck(this, NodeSelector)
      var pToken = _configs.pToken,
        defaultEndpoint = _configs.defaultEndpoint
      if (!ptokensUtils.helpers.isValidPTokenName(pToken))
        throw new Error('Invalid pToken name')
      this.pToken = pToken.toLowerCase()
      var _helpers$parseParams = ptokensUtils.helpers.parseParams(
          _configs,
          _configs.nativeBlockchain
            ? ptokensUtils.helpers.getBlockchainType[_configs.nativeBlockchain]
            : ptokensUtils.helpers.getNativeBlockchainFromPtokenName(
                this.pToken
              )
        ),
        hostBlockchain = _helpers$parseParams.hostBlockchain,
        hostNetwork = _helpers$parseParams.hostNetwork,
        nativeBlockchain = _helpers$parseParams.nativeBlockchain,
        nativeNetwork = _helpers$parseParams.nativeNetwork
      this.hostBlockchain = hostBlockchain
      this.hostNetwork = hostNetwork
      this.nativeBlockchain = nativeBlockchain
      this.nativeNetwork = nativeNetwork
      this.selectedNode = null
      this.nodes = []
      this.defaultEndpoint = defaultEndpoint
    }
    createClass(NodeSelector, [
      {
        key: 'checkConnection',
        value: (function() {
          var _checkConnection = asyncToGenerator(
            regenerator.mark(function _callee(_endpoint) {
              var _timeout,
                info,
                _args = arguments
              return regenerator.wrap(
                function _callee$(_context) {
                  while (1) {
                    switch ((_context.prev = _context.next)) {
                      case 0:
                        _timeout =
                          _args.length > 1 && _args[1] !== undefined
                            ? _args[1]
                            : NODE_CONNECTION_TIMEOUT
                        _context.prev = 1
                        _context.next = 4
                        return makeApiCallWithTimeout(
                          createApi(_endpoint),
                          'GET',
                          '/'
                            .concat(this.pToken, '-on-')
                            .concat(
                              ptokensUtils.helpers.getBlockchainShortType(
                                this.hostBlockchain
                              ),
                              '/get-info'
                            ),
                          null,
                          _timeout
                        )
                      case 4:
                        info = _context.sent
                        if (
                          !(
                            info.host_blockchain === this.hostBlockchain &&
                            info.host_network === this.hostNetwork &&
                            info.native_blockchain === this.nativeBlockchain &&
                            info.native_network === this.nativeNetwork
                          )
                        ) {
                          _context.next = 7
                          break
                        }
                        return _context.abrupt('return', true)
                      case 7:
                        return _context.abrupt('return', false)
                      case 10:
                        _context.prev = 10
                        _context.t0 = _context['catch'](1)
                        return _context.abrupt('return', false)
                      case 13:
                      case 'end':
                        return _context.stop()
                    }
                  }
                },
                _callee,
                this,
                [[1, 10]]
              )
            })
          )
          function checkConnection(_x) {
            return _checkConnection.apply(this, arguments)
          }
          return checkConnection
        })()
      },
      {
        key: 'getApi',
        value: (function() {
          var _getApi = asyncToGenerator(
            regenerator.mark(function _callee2() {
              var node
              return regenerator.wrap(
                function _callee2$(_context2) {
                  while (1) {
                    switch ((_context2.prev = _context2.next)) {
                      case 0:
                        if (this.selectedNode) {
                          _context2.next = 6
                          break
                        }
                        _context2.next = 3
                        return this.select()
                      case 3:
                        node = _context2.sent
                        if (node) {
                          _context2.next = 6
                          break
                        }
                        throw new Error('No Nodes Available')
                      case 6:
                        return _context2.abrupt('return', this.selectedNode.api)
                      case 7:
                      case 'end':
                        return _context2.stop()
                    }
                  }
                },
                _callee2,
                this
              )
            })
          )
          function getApi() {
            return _getApi.apply(this, arguments)
          }
          return getApi
        })()
      },
      {
        key: 'select',
        value: (function() {
          var _select = asyncToGenerator(
            regenerator.mark(function _callee3() {
              var _this = this
              var feature,
                node,
                filteredNodesByFeature,
                nodesNotReachable,
                index,
                selectedNode
              return regenerator.wrap(
                function _callee3$(_context3) {
                  while (1) {
                    switch ((_context3.prev = _context3.next)) {
                      case 0:
                        _context3.prev = 0
                        _context3.next = 3
                        return makeApiCallWithTimeout(
                          getBootNodeApi(
                            ptokensUtils.helpers.getNetworkType(
                              this.hostNetwork
                            )
                          ),
                          'GET',
                          '/peers'
                        )
                      case 3:
                        this.nodes = _context3.sent.peers
                        feature = ''
                          .concat(this.pToken, '-on-')
                          .concat(
                            ptokensUtils.helpers.getBlockchainShortType(
                              this.hostBlockchain
                            )
                          )
                        if (!this.defaultEndpoint) {
                          _context3.next = 14
                          break
                        }
                        node = this.nodes.find(function(_node) {
                          return (
                            _node.webapi === _this.defaultEndpoint &&
                            _node.features.includes(feature)
                          )
                        })
                        _context3.t0 = node
                        if (!_context3.t0) {
                          _context3.next = 12
                          break
                        }
                        _context3.next = 11
                        return this.checkConnection(
                          node.webapi,
                          NODE_CONNECTION_TIMEOUT
                        )
                      case 11:
                        _context3.t0 = _context3.sent
                      case 12:
                        if (!_context3.t0) {
                          _context3.next = 14
                          break
                        }
                        return _context3.abrupt(
                          'return',
                          this.setEndpoint(node.webapi)
                        )
                      case 14:
                        filteredNodesByFeature = this.nodes.filter(function(
                          node
                        ) {
                          return node.features.includes(feature)
                        })
                        if (!(filteredNodesByFeature.length === 0)) {
                          _context3.next = 17
                          break
                        }
                        throw new Error('No Nodes Available')
                      case 17:
                        nodesNotReachable = []
                      case 18:
                        index = Math.floor(
                          Math.random() * filteredNodesByFeature.length
                        )
                        selectedNode = filteredNodesByFeature[index]
                        _context3.next = 22
                        return this.checkConnection(
                          selectedNode.webapi,
                          NODE_CONNECTION_TIMEOUT
                        )
                      case 22:
                        _context3.t1 = _context3.sent
                        if (!_context3.t1) {
                          _context3.next = 25
                          break
                        }
                        _context3.t1 = !nodesNotReachable.includes(selectedNode)
                      case 25:
                        if (!_context3.t1) {
                          _context3.next = 29
                          break
                        }
                        return _context3.abrupt(
                          'return',
                          this.setEndpoint(selectedNode.webapi)
                        )
                      case 29:
                        if (!nodesNotReachable.includes(selectedNode))
                          nodesNotReachable.push(selectedNode)
                      case 30:
                        if (
                          !(
                            nodesNotReachable.length ===
                            filteredNodesByFeature.length
                          )
                        ) {
                          _context3.next = 32
                          break
                        }
                        return _context3.abrupt('return', null)
                      case 32:
                        _context3.next = 18
                        break
                      case 34:
                        _context3.next = 39
                        break
                      case 36:
                        _context3.prev = 36
                        _context3.t2 = _context3['catch'](0)
                        throw new Error(_context3.t2.message)
                      case 39:
                      case 'end':
                        return _context3.stop()
                    }
                  }
                },
                _callee3,
                this,
                [[0, 36]]
              )
            })
          )
          function select() {
            return _select.apply(this, arguments)
          }
          return select
        })()
      },
      {
        key: 'setEndpoint',
        value: function setEndpoint(_endpoint) {
          this.selectedNode = new ptokensNode.Node({
            pToken: this.pToken,
            endpoint: _endpoint,
            blockchain: this.hostBlockchain
          })
          return this.selectedNode
        }
      }
    ])
    return NodeSelector
  })()

  exports.NodeSelector = NodeSelector

  return exports
})({}, axios, ptokensNode, ptokensUtils)
